// Simulationsprogramm fr eine Treibwerksimulation

#include "TRIEBWERK.h"
#int_EXT
EXT_isr() {

}

#int_TIMER1
TIMER1_isr() {

}

#int_TIMER0
TIMER0_isr() {

}


#define		vomtempomat		PIN_A5
#define		poti			PIN_A6

int			steigung = 0;
int			gesch = 0;
int			gas = 0;
static int	maxgas = 1023;
static int	maxtempo = 1023;
static int	maxsteigung = 1023;
static int	motorkonstante = 200;
static int	reibungskonstante = 55;
static int	steigungskonstante = 55;
static int	gewicht = 2500;
static int	zeit = 10;

void geschwindigkeitsberechnung()
{
	//Berechnung der Einzelkrfte fr den Antrieb.
	float steigungskraft = steigungskonstante	*(steigung-512);
	float reibungskraft  = reibungskonstante	*(gesch^2);#
	float motorkraft	 = motorkraftkonstante		*(gas);

	// Berschnung von Antriebskraft und Beschleunigung
	float antriebskraft  = motorkraft - steigungskraft - reibungskraft;
	float beschleunigung = antriebskraft/gewicht;
	
	//Beschleunigung ber das Delay Intervall
	gesch = gesch + (beschleunigung*zeit);
	set_adc_channel(0);

}
void checksteigung()
{
	 int aktsteigung = input(poti);
	 if(aktsteigung == steigung)
	 {
		 return;
	 }
	 else
	 {
		 steigung = aktsteigung;
	 }
}

void checkgas()
{
	 int aktgas = input(vomtempomat);
	 if(aktgas == gas)
	 {
		 return;
	 }
	 else
	 {
		 gas = aktgas;
	 }
 }

void main() 
{


	int16 value;

	   setup_adc_ports(sAN0|VSS_VDD);
	   setup_adc(ADC_CLOCK_DIV_32);
	   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4);
	   setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);
	   setup_comparator(NC_NC_NC_NC);
	   setup_vref(FALSE);
	   enable_interrupts(INT_EXT);
	   enable_interrupts(INT_TIMER1);
	   enable_interrupts(INT_TIMER0);
	   enable_interrupts(GLOBAL);

	set_adc_channel( 0 );


	while(true)
	{
		
		checksteigung();				// Ablesen der Steigung
		
		checkgas();						// Ablesen des Gas
		
		geschwindigkeitsberechnung();	// berechnen der Geschwindigkeit
		
		delay_ms(zeit);					// 10 ms warten 
	}
	return;
	
}
